<template>
   <b-container fluid>
       <b-card>
                      <b-row>
               <h3 class="card-title">LỊCH SỬ GIAO DỊCH</h3>
           </b-row>
        <b-row>
            <b-col md="3" class="my-1">
                <b-form-group horizontal label="Hiển thị">
                    <b-form-select :options="pageOptions" v-model="perPage" />
                </b-form-group>
            </b-col>
        </b-row>
      <b-table striped hover 
               :items="sortedPayments" 
               :fields="fields"
               :current-page="currentPage"
               :per-page="perPage">
          <span slot="status_label" slot-scope="data" v-html="data.value"></span>
        <template slot="actions" slot-scope="row">
        <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->
       <b-button size="sm" @click.stop="showConfirmPaymentForm(row.item, row.index, $event.target)" class="mr-1" variant="primary">
          Confirm
        </b-button>
      </template>       
      </b-table>
          <b-row>
      <b-col md="6" class="my-1">
        <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
      </b-col>
    </b-row>
       </b-card>
   </b-container>

</template>

<script>
import { http } from '../../services'
import { alerts } from '../../utils'
export default {
    data() {
        return {
            fields: [{
                    key: 'id',
                    label: 'Mã DG',
                    sortable: true
                },
                {
                    key: 'agency.name',
                    label: 'Tên đại lý',
                    sortable: true
                },
                {
                    key: 'salesman.name',
                    label: 'Nhân viên GD',
                    sortable: true,
                    // Variant applies to the whole column, including the header and footer
                    // variant: 'danger'
                },
                {
                    key: 'amount',
                    label: 'Số tiền',
                    sortable: true,
                    formatter: (value) => {
                        return Comma(value)
                    }
                },
                {
                    key: 'status_label',
                    label: 'Trạng thái',
                    sortable: true,

                },
                {
                    key: 'created_at',
                    label: 'Ngày tạo',
                    sortable: true,
                    formatter: (value) => {
                        return moment(value).format('DD/MM/YYYY HH:mm:ss')
                    }

                },
                {
                    key: 'actions',
                    label: 'Actions'
                }
            ],
            payments: [

            ],
            currentPage: 1,
            perPage: 5,
            totalRows: 0,
            pageOptions: [5, 10, 15],
        };
    },
    created() {
        this.fetchPayments();
    },
    methods: {
        fetchPayments() {
            http.get('/payment',(response) => {
                this.payments = response.data;
                this.totalRows = response.data.length;
            })
        },
        confirmPayment(payment_id, reference_code) {
           http.post('/payment/confirm', {
                    id: payment_id,
                    reference_code: reference_code
                }, (response) => {
                    if (response.data.status) {
                       alerts.success(esponse.data.msg);

                    } else {
                        alerts.warning(esponse.data.msg);
                    }
                })
        },
        showConfirmPaymentForm(item, index, button) {
            alerts.ajaxRequest('Mã giấý tờ (optional)',item.id,this.confirmPayment);
            // this.modalInfo.title = `Row index: ${index}`
            // this.modalInfo.agency = item.agency;
            // this.$root.$emit('bv::show::modal', 'modalInfo', button)
        },
        

    },
    computed: {
        sortedPayments() {
            return this.payments.sort((a, b) => new Date(b.created_at) - new Date(a.created_at))
        }
    }
};
</script>